import{s as ht,n as vt,o as ft}from"../chunks/scheduler.0f20f9e5.js";import{S as yt,i as $t,g as o,s as i,r as l,A as At,h as s,f as e,c as n,j as A,u as m,x as nt,k as w,y as d,a as r,v as c,d as p,t as _,w as b}from"../chunks/index.fbd8b8e3.js";import{D as H}from"../chunks/Docstring.8771d8c5.js";import{H as rt}from"../chunks/Heading.2451f3bb.js";function wt(pt){let g,S,M,W,x,B,T,_t='<a href="https://jmlr.org/papers/v12/duchi11a.html" rel="nofollow">AdaGrad (Adaptive Gradient)</a> is an adaptive learning rate optimizer. AdaGrad stores a sum of the squared past gradients for each parameter and uses it to scale their learning rate. This allows the learning rate to be automatically lower or higher depending on the magnitude of the gradient, eliminating the need to manually tune the learning rate.',R,z,U,u,k,ot,f,D,st,V,bt="Base Adagrad optimizer.",F,C,J,h,E,dt,y,P,lt,q,gt="8-bit Adagrad optimizer.",K,L,O,v,N,mt,$,I,ct,G,ut="32-bit Adagrad optimizer.",Q,j,X;return x=new rt({props:{title:"AdaGrad",local:"adagrad",headingTag:"h1"}}),z=new rt({props:{title:"Adagrad",local:"api-class ][ bitsandbytes.optim.Adagrad",headingTag:"h2"}}),k=new H({props:{name:"class bitsandbytes.optim.Adagrad",anchor:"bitsandbytes.optim.Adagrad",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.01"},{name:"lr_decay",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"initial_accumulator_value",val:" = 0"},{name:"eps",val:" = 1e-10"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/adagrad.py#L8"}}),D=new H({props:{name:"__init__",anchor:"bitsandbytes.optim.Adagrad.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.01"},{name:"lr_decay",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"initial_accumulator_value",val:" = 0"},{name:"eps",val:" = 1e-10"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],parametersDescription:[{anchor:"bitsandbytes.optim.Adagrad.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.Adagrad.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-2) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.Adagrad.__init__.lr_decay",description:`<strong>lr_decay</strong> (<code>int</code>, defaults to 0) &#x2014;
The learning rate decay.`,name:"lr_decay"},{anchor:"bitsandbytes.optim.Adagrad.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.Adagrad.__init__.initial_accumulator_value",description:`<strong>initial_accumulator_value</strong> (<code>int</code>, defaults to 0) &#x2014;
The initial momemtum values.`,name:"initial_accumulator_value"},{anchor:"bitsandbytes.optim.Adagrad.__init__.eps",description:`<strong>eps</strong> (<code>float</code>, defaults to 1e-10) &#x2014;
The epsilon value prevents division by zero in the optimizer.`,name:"eps"},{anchor:"bitsandbytes.optim.Adagrad.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.Adagrad.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.Adagrad.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.Adagrad.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.Adagrad.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/adagrad.py#L9"}}),C=new rt({props:{title:"Adagrad8bit",local:"bitsandbytes.optim.Adagrad8bit",headingTag:"h2"}}),E=new H({props:{name:"class bitsandbytes.optim.Adagrad8bit",anchor:"bitsandbytes.optim.Adagrad8bit",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.01"},{name:"lr_decay",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"initial_accumulator_value",val:" = 0"},{name:"eps",val:" = 1e-10"},{name:"optim_bits",val:" = 8"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/adagrad.py#L75"}}),P=new H({props:{name:"__init__",anchor:"bitsandbytes.optim.Adagrad8bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.01"},{name:"lr_decay",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"initial_accumulator_value",val:" = 0"},{name:"eps",val:" = 1e-10"},{name:"optim_bits",val:" = 8"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],parametersDescription:[{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-2) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.lr_decay",description:`<strong>lr_decay</strong> (<code>int</code>, defaults to 0) &#x2014;
The learning rate decay.`,name:"lr_decay"},{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.initial_accumulator_value",description:`<strong>initial_accumulator_value</strong> (<code>int</code>, defaults to 0) &#x2014;
The initial momemtum values.`,name:"initial_accumulator_value"},{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.eps",description:`<strong>eps</strong> (<code>float</code>, defaults to 1e-10) &#x2014;
The epsilon value prevents division by zero in the optimizer.`,name:"eps"},{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 8) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.Adagrad8bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/adagrad.py#L76"}}),L=new rt({props:{title:"Adagrad32bit",local:"bitsandbytes.optim.Adagrad32bit",headingTag:"h2"}}),N=new H({props:{name:"class bitsandbytes.optim.Adagrad32bit",anchor:"bitsandbytes.optim.Adagrad32bit",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.01"},{name:"lr_decay",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"initial_accumulator_value",val:" = 0"},{name:"eps",val:" = 1e-10"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/adagrad.py#L143"}}),I=new H({props:{name:"__init__",anchor:"bitsandbytes.optim.Adagrad32bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.01"},{name:"lr_decay",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"initial_accumulator_value",val:" = 0"},{name:"eps",val:" = 1e-10"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],parametersDescription:[{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>, defaults to 1e-2) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.lr_decay",description:`<strong>lr_decay</strong> (<code>int</code>, defaults to 0) &#x2014;
The learning rate decay.`,name:"lr_decay"},{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.initial_accumulator_value",description:`<strong>initial_accumulator_value</strong> (<code>int</code>, defaults to 0) &#x2014;
The initial momemtum values.`,name:"initial_accumulator_value"},{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.eps",description:`<strong>eps</strong> (<code>float</code>, defaults to 1e-10) &#x2014;
The epsilon value prevents division by zero in the optimizer.`,name:"eps"},{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.Adagrad32bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/adagrad.py#L144"}}),{c(){g=o("meta"),S=i(),M=o("p"),W=i(),l(x.$$.fragment),B=i(),T=o("p"),T.innerHTML=_t,R=i(),l(z.$$.fragment),U=i(),u=o("div"),l(k.$$.fragment),ot=i(),f=o("div"),l(D.$$.fragment),st=i(),V=o("p"),V.textContent=bt,F=i(),l(C.$$.fragment),J=i(),h=o("div"),l(E.$$.fragment),dt=i(),y=o("div"),l(P.$$.fragment),lt=i(),q=o("p"),q.textContent=gt,K=i(),l(L.$$.fragment),O=i(),v=o("div"),l(N.$$.fragment),mt=i(),$=o("div"),l(I.$$.fragment),ct=i(),G=o("p"),G.textContent=ut,Q=i(),j=o("p"),this.h()},l(t){const a=At("svelte-u9bgzb",document.head);g=s(a,"META",{name:!0,content:!0}),a.forEach(e),S=n(t),M=s(t,"P",{}),A(M).forEach(e),W=n(t),m(x.$$.fragment,t),B=n(t),T=s(t,"P",{"data-svelte-h":!0}),nt(T)!=="svelte-1l8niyc"&&(T.innerHTML=_t),R=n(t),m(z.$$.fragment,t),U=n(t),u=s(t,"DIV",{class:!0});var Y=A(u);m(k.$$.fragment,Y),ot=n(Y),f=s(Y,"DIV",{class:!0});var Z=A(f);m(D.$$.fragment,Z),st=n(Z),V=s(Z,"P",{"data-svelte-h":!0}),nt(V)!=="svelte-2ft5mo"&&(V.textContent=bt),Z.forEach(e),Y.forEach(e),F=n(t),m(C.$$.fragment,t),J=n(t),h=s(t,"DIV",{class:!0});var tt=A(h);m(E.$$.fragment,tt),dt=n(tt),y=s(tt,"DIV",{class:!0});var et=A(y);m(P.$$.fragment,et),lt=n(et),q=s(et,"P",{"data-svelte-h":!0}),nt(q)!=="svelte-1jvi8fr"&&(q.textContent=gt),et.forEach(e),tt.forEach(e),K=n(t),m(L.$$.fragment,t),O=n(t),v=s(t,"DIV",{class:!0});var at=A(v);m(N.$$.fragment,at),mt=n(at),$=s(at,"DIV",{class:!0});var it=A($);m(I.$$.fragment,it),ct=n(it),G=s(it,"P",{"data-svelte-h":!0}),nt(G)!=="svelte-r8ezau"&&(G.textContent=ut),it.forEach(e),at.forEach(e),Q=n(t),j=s(t,"P",{}),A(j).forEach(e),this.h()},h(){w(g,"name","hf:doc:metadata"),w(g,"content",xt),w(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),w(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,a){d(document.head,g),r(t,S,a),r(t,M,a),r(t,W,a),c(x,t,a),r(t,B,a),r(t,T,a),r(t,R,a),c(z,t,a),r(t,U,a),r(t,u,a),c(k,u,null),d(u,ot),d(u,f),c(D,f,null),d(f,st),d(f,V),r(t,F,a),c(C,t,a),r(t,J,a),r(t,h,a),c(E,h,null),d(h,dt),d(h,y),c(P,y,null),d(y,lt),d(y,q),r(t,K,a),c(L,t,a),r(t,O,a),r(t,v,a),c(N,v,null),d(v,mt),d(v,$),c(I,$,null),d($,ct),d($,G),r(t,Q,a),r(t,j,a),X=!0},p:vt,i(t){X||(p(x.$$.fragment,t),p(z.$$.fragment,t),p(k.$$.fragment,t),p(D.$$.fragment,t),p(C.$$.fragment,t),p(E.$$.fragment,t),p(P.$$.fragment,t),p(L.$$.fragment,t),p(N.$$.fragment,t),p(I.$$.fragment,t),X=!0)},o(t){_(x.$$.fragment,t),_(z.$$.fragment,t),_(k.$$.fragment,t),_(D.$$.fragment,t),_(C.$$.fragment,t),_(E.$$.fragment,t),_(P.$$.fragment,t),_(L.$$.fragment,t),_(N.$$.fragment,t),_(I.$$.fragment,t),X=!1},d(t){t&&(e(S),e(M),e(W),e(B),e(T),e(R),e(U),e(u),e(F),e(J),e(h),e(K),e(O),e(v),e(Q),e(j)),e(g),b(x,t),b(z,t),b(k),b(D),b(C,t),b(E),b(P),b(L,t),b(N),b(I)}}}const xt='{"title":"AdaGrad","local":"adagrad","sections":[{"title":"Adagrad","local":"api-class ][ bitsandbytes.optim.Adagrad","sections":[],"depth":2},{"title":"Adagrad8bit","local":"bitsandbytes.optim.Adagrad8bit","sections":[],"depth":2},{"title":"Adagrad32bit","local":"bitsandbytes.optim.Adagrad32bit","sections":[],"depth":2}],"depth":1}';function Tt(pt){return ft(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Et extends yt{constructor(g){super(),$t(this,g,Tt,wt,ht,{})}}export{Et as component};
