import{s as yt,n as $t,o as Dt}from"../chunks/scheduler.0f20f9e5.js";import{S as St,i as Gt,g as s,s as a,r as d,A as xt,h as r,f as e,c as o,j as D,u as l,x as M,k as S,y as m,a as i,v as p,d as c,t as b,w as _}from"../chunks/index.fbd8b8e3.js";import{D as V}from"../chunks/Docstring.8771d8c5.js";import{H as rt}from"../chunks/Heading.2451f3bb.js";function wt(_t){let g,j,W,B,G,R,x,gt="Stochastic gradient descent (SGD) is a basic gradient descent optimizer to minimize loss given a set of model parameters and updates the parameters in the opposite direction of the gradient. The update is performed on a randomly sampled mini-batch of data from the dataset.",U,w,ht="bitsandbytes also supports momentum and Nesterov momentum to accelerate SGD by adding a weighted average of past gradients to the current gradient.",J,z,K,h,T,mt,f,k,dt,L,ut="Base SGD optimizer.",O,C,Q,u,N,lt,y,P,pt,q,vt="8-bit SGD optimizer.",X,E,Y,v,F,ct,$,A,bt,I,ft="32-bit SGD optimizer.",Z,H,tt;return G=new rt({props:{title:"SGD",local:"sgd",headingTag:"h1"}}),z=new rt({props:{title:"SGD",local:"api-class ][ bitsandbytes.optim.SGD",headingTag:"h2"}}),T=new V({props:{name:"class bitsandbytes.optim.SGD",anchor:"bitsandbytes.optim.SGD",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/sgd.py#L8"}}),k=new V({props:{name:"__init__",anchor:"bitsandbytes.optim.SGD.__init__",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"optim_bits",val:" = 32"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],parametersDescription:[{anchor:"bitsandbytes.optim.SGD.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.SGD.__init__.lr",description:`<strong>lr</strong> (<code>float</code>) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.SGD.__init__.momentum",description:`<strong>momentum</strong> (<code>float</code>, defaults to 0) &#x2014;
The momentum value speeds up the optimizer by taking bigger steps.`,name:"momentum"},{anchor:"bitsandbytes.optim.SGD.__init__.dampening",description:`<strong>dampening</strong> (<code>float</code>, defaults to 0) &#x2014;
The dampening value reduces the momentum of the optimizer.`,name:"dampening"},{anchor:"bitsandbytes.optim.SGD.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.SGD.__init__.nesterov",description:`<strong>nesterov</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use Nesterov momentum.`,name:"nesterov"},{anchor:"bitsandbytes.optim.SGD.__init__.optim_bits",description:`<strong>optim_bits</strong> (<code>int</code>, defaults to 32) &#x2014;
The number of bits of the optimizer state.`,name:"optim_bits"},{anchor:"bitsandbytes.optim.SGD.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.SGD.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.SGD.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.SGD.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/sgd.py#L9"}}),C=new rt({props:{title:"SGD8bit",local:"bitsandbytes.optim.SGD8bit",headingTag:"h2"}}),N=new V({props:{name:"class bitsandbytes.optim.SGD8bit",anchor:"bitsandbytes.optim.SGD8bit",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/sgd.py#L67"}}),P=new V({props:{name:"__init__",anchor:"bitsandbytes.optim.SGD8bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],parametersDescription:[{anchor:"bitsandbytes.optim.SGD8bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.SGD8bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.SGD8bit.__init__.momentum",description:`<strong>momentum</strong> (<code>float</code>, defaults to 0) &#x2014;
The momentum value speeds up the optimizer by taking bigger steps.`,name:"momentum"},{anchor:"bitsandbytes.optim.SGD8bit.__init__.dampening",description:`<strong>dampening</strong> (<code>float</code>, defaults to 0) &#x2014;
The dampening value reduces the momentum of the optimizer.`,name:"dampening"},{anchor:"bitsandbytes.optim.SGD8bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.SGD8bit.__init__.nesterov",description:`<strong>nesterov</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use Nesterov momentum.`,name:"nesterov"},{anchor:"bitsandbytes.optim.SGD8bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.SGD8bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.SGD8bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.SGD8bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/sgd.py#L68"}}),E=new rt({props:{title:"SGD32bit",local:"bitsandbytes.optim.SGD32bit",headingTag:"h2"}}),F=new V({props:{name:"class bitsandbytes.optim.SGD32bit",anchor:"bitsandbytes.optim.SGD32bit",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/sgd.py#L123"}}),A=new V({props:{name:"__init__",anchor:"bitsandbytes.optim.SGD32bit.__init__",parameters:[{name:"params",val:""},{name:"lr",val:""},{name:"momentum",val:" = 0"},{name:"dampening",val:" = 0"},{name:"weight_decay",val:" = 0"},{name:"nesterov",val:" = False"},{name:"args",val:" = None"},{name:"min_8bit_size",val:" = 4096"},{name:"percentile_clipping",val:" = 100"},{name:"block_wise",val:" = True"}],parametersDescription:[{anchor:"bitsandbytes.optim.SGD32bit.__init__.params",description:`<strong>params</strong> (<code>torch.tensor</code>) &#x2014;
The input parameters to optimize.`,name:"params"},{anchor:"bitsandbytes.optim.SGD32bit.__init__.lr",description:`<strong>lr</strong> (<code>float</code>) &#x2014;
The learning rate.`,name:"lr"},{anchor:"bitsandbytes.optim.SGD32bit.__init__.momentum",description:`<strong>momentum</strong> (<code>float</code>, defaults to 0) &#x2014;
The momentum value speeds up the optimizer by taking bigger steps.`,name:"momentum"},{anchor:"bitsandbytes.optim.SGD32bit.__init__.dampening",description:`<strong>dampening</strong> (<code>float</code>, defaults to 0) &#x2014;
The dampening value reduces the momentum of the optimizer.`,name:"dampening"},{anchor:"bitsandbytes.optim.SGD32bit.__init__.weight_decay",description:`<strong>weight_decay</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The weight decay value for the optimizer.`,name:"weight_decay"},{anchor:"bitsandbytes.optim.SGD32bit.__init__.nesterov",description:`<strong>nesterov</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use Nesterov momentum.`,name:"nesterov"},{anchor:"bitsandbytes.optim.SGD32bit.__init__.args",description:`<strong>args</strong> (<code>dict</code>, defaults to <code>None</code>) &#x2014;
A dictionary with additional arguments.`,name:"args"},{anchor:"bitsandbytes.optim.SGD32bit.__init__.min_8bit_size",description:`<strong>min_8bit_size</strong> (<code>int</code>, defaults to 4096) &#x2014;
The minimum number of elements of the parameter tensors for 8-bit optimization.`,name:"min_8bit_size"},{anchor:"bitsandbytes.optim.SGD32bit.__init__.percentile_clipping",description:`<strong>percentile_clipping</strong> (<code>int</code>, defaults to 100) &#x2014;
Adapts clipping threshold automatically by tracking the last 100 gradient norms and clipping the gradient at a certain percentile to improve stability.`,name:"percentile_clipping"},{anchor:"bitsandbytes.optim.SGD32bit.__init__.block_wise",description:`<strong>block_wise</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to independently quantize each block of tensors to reduce outlier effects and improve stability.`,name:"block_wise"}],source:"https://github.com/TimDettmers/bitsandbytes/blob/vr_1081/src/bitsandbytes/optim/sgd.py#L124"}}),{c(){g=s("meta"),j=a(),W=s("p"),B=a(),d(G.$$.fragment),R=a(),x=s("p"),x.textContent=gt,U=a(),w=s("p"),w.textContent=ht,J=a(),d(z.$$.fragment),K=a(),h=s("div"),d(T.$$.fragment),mt=a(),f=s("div"),d(k.$$.fragment),dt=a(),L=s("p"),L.textContent=ut,O=a(),d(C.$$.fragment),Q=a(),u=s("div"),d(N.$$.fragment),lt=a(),y=s("div"),d(P.$$.fragment),pt=a(),q=s("p"),q.textContent=vt,X=a(),d(E.$$.fragment),Y=a(),v=s("div"),d(F.$$.fragment),ct=a(),$=s("div"),d(A.$$.fragment),bt=a(),I=s("p"),I.textContent=ft,Z=a(),H=s("p"),this.h()},l(t){const n=xt("svelte-u9bgzb",document.head);g=r(n,"META",{name:!0,content:!0}),n.forEach(e),j=o(t),W=r(t,"P",{}),D(W).forEach(e),B=o(t),l(G.$$.fragment,t),R=o(t),x=r(t,"P",{"data-svelte-h":!0}),M(x)!=="svelte-q53bao"&&(x.textContent=gt),U=o(t),w=r(t,"P",{"data-svelte-h":!0}),M(w)!=="svelte-xtlqke"&&(w.textContent=ht),J=o(t),l(z.$$.fragment,t),K=o(t),h=r(t,"DIV",{class:!0});var et=D(h);l(T.$$.fragment,et),mt=o(et),f=r(et,"DIV",{class:!0});var nt=D(f);l(k.$$.fragment,nt),dt=o(nt),L=r(nt,"P",{"data-svelte-h":!0}),M(L)!=="svelte-1r01lii"&&(L.textContent=ut),nt.forEach(e),et.forEach(e),O=o(t),l(C.$$.fragment,t),Q=o(t),u=r(t,"DIV",{class:!0});var it=D(u);l(N.$$.fragment,it),lt=o(it),y=r(it,"DIV",{class:!0});var at=D(y);l(P.$$.fragment,at),pt=o(at),q=r(at,"P",{"data-svelte-h":!0}),M(q)!=="svelte-utr5h5"&&(q.textContent=vt),at.forEach(e),it.forEach(e),X=o(t),l(E.$$.fragment,t),Y=o(t),v=r(t,"DIV",{class:!0});var ot=D(v);l(F.$$.fragment,ot),ct=o(ot),$=r(ot,"DIV",{class:!0});var st=D($);l(A.$$.fragment,st),bt=o(st),I=r(st,"P",{"data-svelte-h":!0}),M(I)!=="svelte-wdls4c"&&(I.textContent=ft),st.forEach(e),ot.forEach(e),Z=o(t),H=r(t,"P",{}),D(H).forEach(e),this.h()},h(){S(g,"name","hf:doc:metadata"),S(g,"content",zt),S(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),S(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,n){m(document.head,g),i(t,j,n),i(t,W,n),i(t,B,n),p(G,t,n),i(t,R,n),i(t,x,n),i(t,U,n),i(t,w,n),i(t,J,n),p(z,t,n),i(t,K,n),i(t,h,n),p(T,h,null),m(h,mt),m(h,f),p(k,f,null),m(f,dt),m(f,L),i(t,O,n),p(C,t,n),i(t,Q,n),i(t,u,n),p(N,u,null),m(u,lt),m(u,y),p(P,y,null),m(y,pt),m(y,q),i(t,X,n),p(E,t,n),i(t,Y,n),i(t,v,n),p(F,v,null),m(v,ct),m(v,$),p(A,$,null),m($,bt),m($,I),i(t,Z,n),i(t,H,n),tt=!0},p:$t,i(t){tt||(c(G.$$.fragment,t),c(z.$$.fragment,t),c(T.$$.fragment,t),c(k.$$.fragment,t),c(C.$$.fragment,t),c(N.$$.fragment,t),c(P.$$.fragment,t),c(E.$$.fragment,t),c(F.$$.fragment,t),c(A.$$.fragment,t),tt=!0)},o(t){b(G.$$.fragment,t),b(z.$$.fragment,t),b(T.$$.fragment,t),b(k.$$.fragment,t),b(C.$$.fragment,t),b(N.$$.fragment,t),b(P.$$.fragment,t),b(E.$$.fragment,t),b(F.$$.fragment,t),b(A.$$.fragment,t),tt=!1},d(t){t&&(e(j),e(W),e(B),e(R),e(x),e(U),e(w),e(J),e(K),e(h),e(O),e(Q),e(u),e(X),e(Y),e(v),e(Z),e(H)),e(g),_(G,t),_(z,t),_(T),_(k),_(C,t),_(N),_(P),_(E,t),_(F),_(A)}}}const zt='{"title":"SGD","local":"sgd","sections":[{"title":"SGD","local":"api-class ][ bitsandbytes.optim.SGD","sections":[],"depth":2},{"title":"SGD8bit","local":"bitsandbytes.optim.SGD8bit","sections":[],"depth":2},{"title":"SGD32bit","local":"bitsandbytes.optim.SGD32bit","sections":[],"depth":2}],"depth":1}';function Tt(_t){return Dt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Et extends St{constructor(g){super(),Gt(this,g,Tt,wt,yt,{})}}export{Et as component};
